// mtest.H
#ifndef _MTEST_H
#define _MTEST_H

#include <stdlib.h>
#include <string.h>

class Thing {
public:
  Thing();
  virtual char *Type()=0;
  virtual char *Type2()=0;
};

class Extra {
  int dummy;
};

class ThingA : public Extra, public Thing {
public:
  ThingA();
  virtual char *Type();
  virtual char *Type2();
};

class ThingB : public Extra, public Thing {
public:
  ThingB();
  virtual char *Type();
  virtual char *Type2();
};

class ThingC : public Extra, public Thing {
public:
  ThingC();
  virtual char *Type();
  virtual char *Type2();
};

class System {
public:
  System(void);
  virtual ~System(void);
  Thing* someThing(int arg);
  Thing* cThing(void);
  ThingC& cThing2(void);
  void putString(char *s);
  void putString2(char *s);
  char* getString(void) 	{ return str; }
  char* getString2(void);
private:
  ThingA *thingA;
  ThingB *thingB;
  ThingC *thingC;
  char *str;
};

#include <stdlib.h>
#include <string.h>

class SlotTest {
public:
  SlotTest(char *s) { str = strdup(s); slottestslot = strlen(str); }
  ~SlotTest(void)   { free(str); }

  char *slottestmethod(void) { return str; }

  int slottestslot;
  char *str;
// Adapt this for classSlots too
  static int testClassSlot;
  int getClassSlot(void) { return testClassSlot; }
};

#include <ctype.h>	// toupper()

class InheritTest : public SlotTest {
public:
    char *inherittestslot;

    InheritTest(char *s) : SlotTest(s)   { inherittestslot = 0; }
    ~InheritTest(void)   { if(inherittestslot) delete [] inherittestslot; }

    char* inherittestmethod(void)  
            { if(inherittestslot) delete [] inherittestslot;
	      inherittestslot = new char[strlen(str)+1];
	      int i; for(i=0; i<strlen(str)+1; ++i)
		  inherittestslot[i] = toupper(str[i]);
	      return inherittestslot; }
};

#include <tcl.h>

extern Tcl_Interp *testInterp;

class ReturnableObj {	// something that records its cons/des
public:
    int inst;
    int tag;
    static int count;
    ReturnableObj(int t) {
	inst = count++;
	tag = t;
	char s[256];
	sprintf(s, "ReturnableObj %d created with tag %d", inst, tag);
	Tcl_SetVar (testInterp, "results", s,
		    TCL_GLOBAL_ONLY | TCL_LIST_ELEMENT | TCL_APPEND_VALUE);
    }
    ReturnableObj(const ReturnableObj& ro) {   // copy constructor
	inst = count++;
	tag = ro.tag;
	char s[256];
	sprintf(s, "ReturnableObj %d copied with tag %d", inst, tag);
	Tcl_SetVar (testInterp, "results", s,
		    TCL_GLOBAL_ONLY | TCL_LIST_ELEMENT | TCL_APPEND_VALUE);
    }
    ~ReturnableObj(void) {
	char s[256];
	sprintf(s, "ReturnableObj %d with tag %d destroyed", inst, tag);
	Tcl_SetVar (testInterp, "results", s,
		    TCL_GLOBAL_ONLY | TCL_LIST_ELEMENT | TCL_APPEND_VALUE);
    }
};

class ObjRtnTest {	// test Cdl 'obj' return type - a new object
public:
    ObjRtnTest() {}
    ~ObjRtnTest() {}
    ReturnableObj getObj(int t) {
	ReturnableObj ro(t);
	return ro;
    }
};

class ObjPassTest {	// test syntax checking for passed objects
public:
    ObjPassTest() {}
    ~ObjPassTest() {}
    int takesPtr(ReturnableObj* rop) {
	return rop->tag;
    }
    int takesRef(ReturnableObj& ror) {
	return ror.tag;
    }
};

class DefaultValTest {	// test default values for methods
public:
    DefaultValTest(char *s, int v) {val1 = v; val2 = 0; val3 = strdup(s);}
    ~DefaultValTest() {free(val3);}
    void setVals(int v1, int v2=33) {
	val1 = v1; val2 = v2;
    }
    int val1;
    int val2;
    char *val3;
};

class FakeSlotTest { // test fake slots added by interface
public:
    int val;

    FakeSlotTest(int i) {val = 2*i;}
    ~FakeSlotTest()     {};
};    

class FakeConstrArgs {	// can fake slots be used for constructor args?
private:
    int rows;
    int cols;
public:
    FakeConstrArgs(int r, int c) {rows = r; cols = c;};
    ~FakeConstrArgs(void) {};
    int Rows(void) {return rows;}
    int Cols(void) {return cols;}
    void Resize(int r, int c) { rows = r; cols = c;};
};

/* test for cname aliasing */
class CppName {
public:
    int val;

    CppName(int i) { val = i; }
    ~CppName(void) {}
    int foo(void) { return val; }

    static foob(void) { return 77; }
};


#endif /* _MTEST_H */
